Subject: bug#25557: Documentation of format doesn't describe "g" accurately

From: Clément Pit--Claudel <[email-masked]>
Date: Sat, 28 Jan 2017 10:45:09 -0500

On 2017-01-28 10:23, Eli Zaretskii wrote:
>> Cc: [email-masked]
>> From: Clément Pit--Claudel <[email-masked]>
>> Date: Sat, 28 Jan 2017 10:04:33 -0500
>>
>>>> On a related note, is there a way to get a shortest representation of a number? Something like %g, but without exponents.
>>>
>>> Sorry, I don't understand the question.  How can you represent an
>>> arbitrary number without exponents at all, except by %f?
>>
>> I'd like something like this (with a hypothetical %q):
>>
>>   (format "%.3q" 3) ⇒ "3"
>>   (format "%.3q" 3.00) ⇒ "3"
>>   (format "%.3q" 3.30) ⇒ "3.3"
>>   (format "%.3q" 3.05) ⇒ "3.05"
>>   (format "%.3q" 3.352) ⇒ "3.35"
>>   (format "%.3q" 3100000) ⇒ "3100000"
>>
>> This is in fact just the same as 'g', except for the last entry (%g produces "3.1e+06"). Is this achievable?
> 
> Yes, if you use "%.7g".  In general, use "%.Ng" if you want up to N
> digits in the printed representation.
> 
> Does that answer your question?

Almost: though this works for the last example, it breaks the one before the last (I'm looking for a format specifier that would constrain the number of decimals, not the number of digits, so that (format "%.3q" 30.352) would produce "30.35" — maybe all these examples should have had %.2q instead of %.3q, in fact).